#define __NR_SYSCALL_BASE	0x900000

struct 
{
	char *str;
	int num;
} syscall_desc[] =

{
	{ "exit", __NR_SYSCALL_BASE+  1 },
	{ "fork", __NR_SYSCALL_BASE+  2 },
	{ "read", __NR_SYSCALL_BASE+  3 },
	{ "write", __NR_SYSCALL_BASE+  4 },
	{ "open", __NR_SYSCALL_BASE+  5 },
	{ "close", __NR_SYSCALL_BASE+  6 },
	{ "waitpid", __NR_SYSCALL_BASE+  7 },
	{ "creat", __NR_SYSCALL_BASE+  8 },
	{ "link", __NR_SYSCALL_BASE+  9 },
	{ "unlink", __NR_SYSCALL_BASE+ 10 },
	{ "execve", __NR_SYSCALL_BASE+ 11 },
	{ "chdir", __NR_SYSCALL_BASE+ 12 },
	{ "time", __NR_SYSCALL_BASE+ 13 },
	{ "mknod", __NR_SYSCALL_BASE+ 14 },
	{ "chmod", __NR_SYSCALL_BASE+ 15 },
	{ "lchown", __NR_SYSCALL_BASE+ 16 },
	{ "break", __NR_SYSCALL_BASE+ 17 },

	{ "lseek", __NR_SYSCALL_BASE+ 19 },
	{ "getpid", __NR_SYSCALL_BASE+ 20 },
	{ "mount", __NR_SYSCALL_BASE+ 21 },
	{ "umount", __NR_SYSCALL_BASE+ 22 },
	{ "setuid", __NR_SYSCALL_BASE+ 23 },
	{ "getuid", __NR_SYSCALL_BASE+ 24 },
	{ "stime", __NR_SYSCALL_BASE+ 25 },
	{ "ptrace", __NR_SYSCALL_BASE+ 26 },
	{ "alarm", __NR_SYSCALL_BASE+ 27 },

	{ "pause", __NR_SYSCALL_BASE+ 29 },
	{ "utime", __NR_SYSCALL_BASE+ 30 },
	{ "stty", __NR_SYSCALL_BASE+ 31 },
	{ "gtty", __NR_SYSCALL_BASE+ 32 },
	{ "access", __NR_SYSCALL_BASE+ 33 },
	{ "nice", __NR_SYSCALL_BASE+ 34 },
	{ "ftime", __NR_SYSCALL_BASE+ 35 },
	{ "sync", __NR_SYSCALL_BASE+ 36 },
	{ "kill", __NR_SYSCALL_BASE+ 37 },
	{ "rename", __NR_SYSCALL_BASE+ 38 },
	{ "mkdir", __NR_SYSCALL_BASE+ 39 },
	{ "rmdir", __NR_SYSCALL_BASE+ 40 },
	{ "dup", __NR_SYSCALL_BASE+ 41 },
	{ "pipe", __NR_SYSCALL_BASE+ 42 },
	{ "times", __NR_SYSCALL_BASE+ 43 },
	{ "prof", __NR_SYSCALL_BASE+ 44 },
	{ "brk", __NR_SYSCALL_BASE+ 45 },
	{ "setgid", __NR_SYSCALL_BASE+ 46 },
	{ "getgid", __NR_SYSCALL_BASE+ 47 },
	{ "signal", __NR_SYSCALL_BASE+ 48 },
	{ "geteuid", __NR_SYSCALL_BASE+ 49 },
	{ "getegid", __NR_SYSCALL_BASE+ 50 },
	{ "acct", __NR_SYSCALL_BASE+ 51 },
	{ "umount2", __NR_SYSCALL_BASE+ 52 },
	{ "lock", __NR_SYSCALL_BASE+ 53 },
	{ "ioctl", __NR_SYSCALL_BASE+ 54 },
	{ "fcntl", __NR_SYSCALL_BASE+ 55 },
	{ "mpx", __NR_SYSCALL_BASE+ 56 },
	{ "setpgid", __NR_SYSCALL_BASE+ 57 },
	{ "ulimit", __NR_SYSCALL_BASE+ 58 },

	{ "umask", __NR_SYSCALL_BASE+ 60 },
	{ "chroot", __NR_SYSCALL_BASE+ 61 },
	{ "ustat", __NR_SYSCALL_BASE+ 62 },
	{ "dup2", __NR_SYSCALL_BASE+ 63 },
	{ "getppid", __NR_SYSCALL_BASE+ 64 },
	{ "getpgrp", __NR_SYSCALL_BASE+ 65 },
	{ "setsid", __NR_SYSCALL_BASE+ 66 },
	{ "sigaction", __NR_SYSCALL_BASE+ 67 },
	{ "sgetmask", __NR_SYSCALL_BASE+ 68 },
	{ "ssetmask", __NR_SYSCALL_BASE+ 69 },
	{ "setreuid", __NR_SYSCALL_BASE+ 70 },
	{ "setregid", __NR_SYSCALL_BASE+ 71 },
	{ "sigsuspend", __NR_SYSCALL_BASE+ 72 },
	{ "sigpending", __NR_SYSCALL_BASE+ 73 },
	{ "sethostname", __NR_SYSCALL_BASE+ 74 },
	{ "setrlimit", __NR_SYSCALL_BASE+ 75 },
	{ "getrlimit", __NR_SYSCALL_BASE+ 76 },	/* Back compat 2GB limited rlimit */
	{ "getrusage", __NR_SYSCALL_BASE+ 77 },
	{ "gettimeofday", __NR_SYSCALL_BASE+ 78 },
	{ "settimeofday", __NR_SYSCALL_BASE+ 79 },
	{ "getgroups", __NR_SYSCALL_BASE+ 80 },
	{ "setgroups", __NR_SYSCALL_BASE+ 81 },
	{ "select", __NR_SYSCALL_BASE+ 82 },
	{ "symlink", __NR_SYSCALL_BASE+ 83 },

	{ "readlink", __NR_SYSCALL_BASE+ 85 },
	{ "uselib", __NR_SYSCALL_BASE+ 86 },
	{ "swapon", __NR_SYSCALL_BASE+ 87 },
	{ "reboot", __NR_SYSCALL_BASE+ 88 },
	{ "readdir", __NR_SYSCALL_BASE+ 89 },
	{ "mmap", __NR_SYSCALL_BASE+ 90 },
	{ "munmap", __NR_SYSCALL_BASE+ 91 },
	{ "truncate", __NR_SYSCALL_BASE+ 92 },
	{ "ftruncate", __NR_SYSCALL_BASE+ 93 },
	{ "fchmod", __NR_SYSCALL_BASE+ 94 },
	{ "fchown", __NR_SYSCALL_BASE+ 95 },
	{ "getpriority", __NR_SYSCALL_BASE+ 96 },
	{ "setpriority", __NR_SYSCALL_BASE+ 97 },
	{ "profil", __NR_SYSCALL_BASE+ 98 },
	{ "statfs", __NR_SYSCALL_BASE+ 99 },
	{ "fstatfs", __NR_SYSCALL_BASE+100 },
	{ "ioperm", __NR_SYSCALL_BASE+101 },
	{ "socketcall", __NR_SYSCALL_BASE+102 },
	{ "syslog", __NR_SYSCALL_BASE+103 },
	{ "setitimer", __NR_SYSCALL_BASE+104 },
	{ "getitimer", __NR_SYSCALL_BASE+105 },
	{ "stat", __NR_SYSCALL_BASE+106 },
	{ "lstat", __NR_SYSCALL_BASE+107 },
	{ "fstat", __NR_SYSCALL_BASE+108 },


	{ "vhangup", __NR_SYSCALL_BASE+111 },
	{ "idle", __NR_SYSCALL_BASE+112 },
	{ "syscall", __NR_SYSCALL_BASE+113 }, /* syscall to call a syscall! */
	{ "wait4", __NR_SYSCALL_BASE+114 },
	{ "swapoff", __NR_SYSCALL_BASE+115 },
	{ "sysinfo", __NR_SYSCALL_BASE+116 },
	{ "ipc", __NR_SYSCALL_BASE+117 },
	{ "fsync", __NR_SYSCALL_BASE+118 },
	{ "sigreturn", __NR_SYSCALL_BASE+119 },
	{ "clone", __NR_SYSCALL_BASE+120 },
	{ "setdomainname", __NR_SYSCALL_BASE+121 },
	{ "uname", __NR_SYSCALL_BASE+122 },
	{ "modify_ldt", __NR_SYSCALL_BASE+123 },
	{ "adjtimex", __NR_SYSCALL_BASE+124 },
	{ "mprotect", __NR_SYSCALL_BASE+125 },
	{ "sigprocmask", __NR_SYSCALL_BASE+126 },
	{ "create_module", __NR_SYSCALL_BASE+127 },
	{ "init_module", __NR_SYSCALL_BASE+128 },
	{ "delete_module", __NR_SYSCALL_BASE+129 },
	{ "get_kernel_syms", __NR_SYSCALL_BASE+130 },
	{ "quotactl", __NR_SYSCALL_BASE+131 },
	{ "getpgid", __NR_SYSCALL_BASE+132 },
	{ "fchdir", __NR_SYSCALL_BASE+133 },
	{ "bdflush", __NR_SYSCALL_BASE+134 },
	{ "sysfs", __NR_SYSCALL_BASE+135 },
	{ "personality", __NR_SYSCALL_BASE+136 },
	{ "afs_syscall", __NR_SYSCALL_BASE+137 }, /* Syscall for Andrew File System */
	{ "setfsuid", __NR_SYSCALL_BASE+138 },
	{ "setfsgid", __NR_SYSCALL_BASE+139 },
	{ "_llseek", __NR_SYSCALL_BASE+140 },
	{ "getdents", __NR_SYSCALL_BASE+141 },
	{ "_newselect", __NR_SYSCALL_BASE+142 },
	{ "flock", __NR_SYSCALL_BASE+143 },
	{ "msync", __NR_SYSCALL_BASE+144 },
	{ "readv", __NR_SYSCALL_BASE+145 },
	{ "writev", __NR_SYSCALL_BASE+146 },
	{ "getsid", __NR_SYSCALL_BASE+147 },
	{ "fdatasync", __NR_SYSCALL_BASE+148 },
	{ "_sysctl", __NR_SYSCALL_BASE+149 },
	{ "mlock", __NR_SYSCALL_BASE+150 },
	{ "munlock", __NR_SYSCALL_BASE+151 },
	{ "mlockall", __NR_SYSCALL_BASE+152 },
	{ "munlockall", __NR_SYSCALL_BASE+153 },
	{ "sched_setparam", __NR_SYSCALL_BASE+154 },
	{ "sched_getparam", __NR_SYSCALL_BASE+155 },
	{ "sched_setscheduler", __NR_SYSCALL_BASE+156 },
	{ "sched_getscheduler", __NR_SYSCALL_BASE+157 },
	{ "sched_yield", __NR_SYSCALL_BASE+158 },
	{ "sched_get_priority_max", __NR_SYSCALL_BASE+159 },
	{ "sched_get_priority_min", __NR_SYSCALL_BASE+160 },
	{ "sched_rr_get_interval", __NR_SYSCALL_BASE+161 },
	{ "nanosleep", __NR_SYSCALL_BASE+162 },
	{ "mremap", __NR_SYSCALL_BASE+163 },
	{ "setresuid", __NR_SYSCALL_BASE+164 },
	{ "getresuid", __NR_SYSCALL_BASE+165 },
	{ "vm86", __NR_SYSCALL_BASE+166 },
	{ "query_module", __NR_SYSCALL_BASE+167 },
	{ "poll", __NR_SYSCALL_BASE+168 },
	{ "nfsservctl", __NR_SYSCALL_BASE+169 },
	{ "setresgid", __NR_SYSCALL_BASE+170 },
	{ "getresgid", __NR_SYSCALL_BASE+171 },
	{ "prctl", __NR_SYSCALL_BASE+172 },
	{ "rt_sigreturn", __NR_SYSCALL_BASE+173 },
	{ "rt_sigaction", __NR_SYSCALL_BASE+174 },
	{ "rt_sigprocmask", __NR_SYSCALL_BASE+175 },
	{ "rt_sigpending", __NR_SYSCALL_BASE+176 },
	{ "rt_sigtimedwait", __NR_SYSCALL_BASE+177 },
	{ "rt_sigqueueinfo", __NR_SYSCALL_BASE+178 },
	{ "rt_sigsuspend", __NR_SYSCALL_BASE+179 },
	{ "pread", __NR_SYSCALL_BASE+180 },
	{ "pwrite", __NR_SYSCALL_BASE+181 },
	{ "chown", __NR_SYSCALL_BASE+182 },
	{ "getcwd", __NR_SYSCALL_BASE+183 },
	{ "capget", __NR_SYSCALL_BASE+184 },
	{ "capset", __NR_SYSCALL_BASE+185 },
	{ "sigaltstack", __NR_SYSCALL_BASE+186 },
	{ "sendfile", __NR_SYSCALL_BASE+187 },
					/* 188 reserved */
					/* 189 reserved */
	{ "vfork", __NR_SYSCALL_BASE+190 },
	{ "ugetrlimit", __NR_SYSCALL_BASE+191 },	/* SuS compliant getrlimit */
	{ "mmap2", __NR_SYSCALL_BASE+192 },
	{ "truncate64", __NR_SYSCALL_BASE+193 },
	{ "ftruncate64", __NR_SYSCALL_BASE+194 },
	{ "stat64", __NR_SYSCALL_BASE+195 },
	{ "lstat64", __NR_SYSCALL_BASE+196 },
	{ "fstat64", __NR_SYSCALL_BASE+197 },
	{ "lchown32", __NR_SYSCALL_BASE+198 },
	{ "getuid32", __NR_SYSCALL_BASE+199 },
	{ "getgid32", __NR_SYSCALL_BASE+200 },
	{ "geteuid32", __NR_SYSCALL_BASE+201 },
	{ "getegid32", __NR_SYSCALL_BASE+202 },
	{ "setreuid32", __NR_SYSCALL_BASE+203 },
	{ "setregid32", __NR_SYSCALL_BASE+204 },
	{ "getgroups32", __NR_SYSCALL_BASE+205 },
	{ "setgroups32", __NR_SYSCALL_BASE+206 },
	{ "fchown32", __NR_SYSCALL_BASE+207 },
	{ "setresuid32", __NR_SYSCALL_BASE+208 },
	{ "getresuid32", __NR_SYSCALL_BASE+209 },
	{ "setresgid32", __NR_SYSCALL_BASE+210 },
	{ "getresgid32", __NR_SYSCALL_BASE+211 },
	{ "chown32", __NR_SYSCALL_BASE+212 },
	{ "setuid32", __NR_SYSCALL_BASE+213 },
	{ "setgid32", __NR_SYSCALL_BASE+214 },
	{ "setfsuid32", __NR_SYSCALL_BASE+215 },
	{ "setfsgid32", __NR_SYSCALL_BASE+216 },
	{ "getdents64", __NR_SYSCALL_BASE+217 },
	{ "pivot_root", __NR_SYSCALL_BASE+218 },
	{ "mincore", __NR_SYSCALL_BASE+219 },
	{ "madvise", __NR_SYSCALL_BASE+220 },
	{ "fcntl64", __NR_SYSCALL_BASE+221 },
	{ NULL, 0 }
};

/*
 * The following SWIs are ARM private.
#define __ARM_NR_BASE", __NR_SYSCALL_BASE+0x0f0000 },
#define __ARM_NR_breakpoint", __ARM_NR_BASE+1 },
#define __ARM_NR_cacheflush", __ARM_NR_BASE+2 },
#define __ARM_NR_usr26", __ARM_NR_BASE+3 },
#define __ARM_NR_usr32", __ARM_NR_BASE+4 },
*/

#define __ASSEMBLY__
#include "include/hardware.h"

struct 
{
	int num;
	char *str;
} ports_desc[] =

{
	{ JASPER_TIMER_BASE, "TIMER" },
	{ JASPER_INT_CONTROLLER_BASE, "INTERRUPT" },
	{ JASPER_MAC_BASE, "MAC" },
	{ JASPER_UART0_BASE, "UART0" },
	{ JASPER_UART1_BASE, "UART1" },
	{ JASPER_PIO0_BASE, "PIO0" },
	{ JASPER_PIO1_BASE, "PIO1" },
	{ JASPER_I2C_MASTER_BASE, "I2C_MASTER" },
	{ JASPER_I2C_SLAVE_BASE, "I2C_SLAVE" },
	{ JASPER_IDE_BASE, "IDE" },
	{ JASPER_IDE_DMA_BASE, "IDE_DMA" },
	{ JASPER_DVD_BASE, "DVD" },
	{ JASPER_FIP_BASE, "FIP" },
	{ JASPER_DVD_DMA_BASE, "DVD_DMA" },
	{ JASPER_RTC_BASE, "RTC" },
	{ JASPER_HOST_SLAVE_QUASAR_BASE, "HOST_QUASAR" },
	{ JASPER_I2S_BASE, "I2S" },
	{ JASPER_SPI_I2S_DMA_BASE, "I2S_DMA" },
	{ JASPER_SPI_BASE, "SPI" },
	{ JASPER_SYSCTRL_BASE, "JASPER" },
	{ JASPER_QUASAR_BASE, "QUASAR" },
	{ -1, NULL }
};
